/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */

// declating and initialising some variables
float x = 1;
float y = random(50,150);
float deltaX = random(1,5);
/*
note that this can be done in two steps like this:
 float X; // first declare
 x = 1;   // secondly assign a value to it
 */

void setup() { // just when starting up
  frameRate(20); // fps
  size(300, 200); // window size
  background(100); // bg color
  noStroke();
  color c1 = color(random(255), random(255), random(255));
  fill(c1);
}

/* 
  for(int i=0; i<100; i++){
    println("i am looping");
  }
 this for loop can be described like this in normal language:
 given a counter called i that can contain integers and with initial value of 0,
 increase its value by 1 unit (++) and execute the lines of code within the for loop
 curly brackets {} until counter i reaches the maximun value (100), at this point exit the for loop
 */

void draw(){ // this is our main loop
  background(255);
  ellipse(x, y, 55, 55);
  // try commenting/uncomenting the following lines before to experiment with different for loops
  for(int i=0; i<100; i++){ // during 70 px to the right from ellipse center draw points at random Y positions around -5to+5
    //for(int i=30; i<100; i++){ // from ellipse edge to the right 
    //for(int i=-60; i<100; i++){ // start from left of ellipse
    //for(int i=-60; i<100; i=i+10){ // jump 10 every for loop
    rect(x+i, y+random(-5,5), 1,1);
  }

  x = x+deltaX; // increases x by deltaX amount, this causes the circle to move to the right
  if (x>=300){ // if circle gets to the right end
    x=1;       // then it goes back to left
  }
}
