/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */


/*in this case we want each of them to remember its color
for this we need that they remember their color and sets it with the fill() command
each time before drawing itself
*/

CircleBounce c, d;

void setup() { // just when starting up
   frameRate(30); // fps
   size(300, 200); // window size
   background(100); // bg color
   noStroke();
   //changeColor();
   c = new CircleBounce();
   d = new CircleBounce();
  }
  
  
color randRGB(){ // returns data type color
 return color(random(255), random(255), random(255));
  }
  

void draw(){ // this is our main loop
    background(100); // clean background
    c.circleBounceDraw();
    d.circleBounceDraw();
}


class CircleBounce{
  float x = 1;
  float y = random(50,150);
  float deltaX = random(1,5);
  float deltaY = random(1,5);
  color c = randRGB();

  void changeMyColor(){
     c = randRGB();
   }
   
  void circleBounceDraw(){
    fill(c); // set my color as fill color
    ellipse(x, y, 55, 55);
    
    x = x+deltaX; // moves x by deltaX amouth
    y = y+deltaY; // moves y by deltaY amouth
    if (x>=300 || x<=0){
      deltaX = -deltaX; //change X direction
      changeMyColor();
    }
    if (y>=200 || y<=0){
      deltaY = -deltaY; //change Y direction
      changeMyColor();
    }
   }
}


