
 
import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress myRemoteLocation;
int r,g,b;

void setup() {
  size(400,400);
  frameRate(25);
  oscP5 = new OscP5(this,12000);
  myRemoteLocation = new NetAddress("127.0.0.1",57120);
  
  oscP5.plug(this,"testFunction","/testB"); //bind address to function
  
  r = 155;
  g = 100;
  b = 100;
}


public void testFunction(int theR, int theG, int theB) {
  println(" 2 ints received: "+theR+", "+theG+", "+theB);  //RGB
  r = theR;
  g = theG;
  b = theB;
}

void draw() {
  background(r,g,b);  
}

void mousePressed() {
  OscMessage myMouseLoc = new OscMessage("/testA");
  myMouseLoc.add(mouseY); //sending mouseLoc
  myMouseLoc.add(mouseX);
  oscP5.send(myMouseLoc, myRemoteLocation); 
}

void oscEvent(OscMessage theOscMessage) {
  if(theOscMessage.isPlugged()==false) { // not bind to a responder
    print(" addrpattern: "+theOscMessage.addrPattern());
    println(" typetag: "+theOscMessage.typetag());
  }
}
